---
- name: Backup Jira Application and Database
  hosts: all
  become: true
  remote_user: admin
  pre_tasks:
  - name: backup date
    command: date +%m%d%y-%H%M
    register: backup_date
#  - debug: var=backup_date

  tasks:
# Database Backup
  - name: Backup Jira Database
    block:
    - name: db | mount backup storage
      mount:
        src: "{{ backup_storage_remote }}"
        path: "{{ backup_storage_local }}"
        fstype: nfs
        state: mounted

    - name: db | make backup directories
      file:
        path: '{{ backup_storage_local }}/database/'
        state: directory
        owner: postgres
        group: postgres
        mode: 0700
        seuser: system_u
        setype: object_r
        serole: postgresql_db_t
        selevel: s0

    - name: db | backup jira database
      become_user: postgres
      postgresql_db:
        db: jira
        state: dump
        target: '{{ backup_storage_local }}/database/{{ backup_date.stdout }}.gz.tar'
# There should be a check here to determine if the backup was successful.
    - name: db | remove symbolic link
      file:
        path: '{{ backup_storage_local }}/database/latest.gz.tar'
        state: absent
#  - debug: var=backup_link

    - name: db | create lastest symbolic link
      file:
        src: '{{ backup_storage_local }}/database/{{ backup_date.stdout }}.gz.tar'
        dest: '{{ backup_storage_local }}/database/latest.gz.tar'
        state: link
    tags: ['db_backup']
    when: inventory_hostname in groups['db_server']
#
#
#
### Jira Application Backup
  - name: Backup Jira Application
    block:
    - name: app | mount backup storage
      mount:
        src: "{{ backup_storage_remote }}"
        path: "{{ backup_storage_local }}"
        fstype: nfs
        state: mounted

    - name: app | make backup directories
      file:
        path: '{{ backup_storage_local }}/application'
        state: directory
        mode: 0700

    - name: app | backup directory
      archive:
        path: /var/atlassian/application-data/jira/data
        dest: '{{ backup_storage_local }}/application/{{ backup_date.stdout }}.gz.tar'
        format: gz
# There should be a check here to determine if the backup was successful.
    - name: app | remove symbolic link
      file:
        path: '{{ backup_storage_local }}/application/latest.gz.tar'
        state: absent
#  - debug: var=backup_link

    - name: app | create lastest symbolic link
      file:
        src: '{{ backup_storage_local }}/application/{{ backup_date.stdout }}.gz.tar'
        dest: '{{ backup_storage_local }}/application/latest.gz.tar'
        state: link
    tags: ['app_backup']
    when: inventory_hostname in groups['app_server']
# End Block
